//SCREENPLAY（シナリオ） jsファイル

screenplay = sp = new Object();

sp.player = new Object();
	sp.player.x = 0;
	sp.player.y = 0;
	sp.player.items = new Array();


//イベントチェック
sp.check = async function() {
	var playerXY = currentMap.id + " " + this.player.x + "," + this.player.y;
	for( var name in this.xy ) {
		if( name == playerXY ) {
			//イベント中はマップ移動処理しない
			var backup1 = onkeydown;
			var backup2 = onkeyup;
			onkeydown = null;
			onkeyup = null;
			keys = new Array();
			
			//イベント実行
			await delay( 100 );	//コマ跳び防止用
			await this.xy[ name ].bind( this )();
			
			//マップ移動処理再開
			onkeydown = backup1;
			onkeyup = backup2;
			break;
		}
	}
	
};

//---各イベント

//プログラム開始時
sp.poweron = async function() {
	//タイトル画面
	titleScene.open();
	await hitanykey();
	
	//オープニング
	titleScene.close();
	mapScene.open();
	goto( "radatomcastle", 2, 2 );
	await message( "大臣は言いました。", true );
	await message( "勇者よ！よくぞ　まいられた！" );
	await message( "悪政を しいる「シャフリヤール王」を説得し、この国に平和をもたらしてくれ！" );
	await message( "ではゆけ！勇者よ！" );
}

//マップ上の各座標に乗ったとき
sp.xy = {

	"radatomcastle 2,4"	: async function() {
		//宮殿から出る
		
		goto( "arefgald", 5, 4 );
	},
	
	"arefgald 5,4"	: async function() {
		//宮殿へ入る
		
		goto( "radatomcastle", 2,4 );
	},
	
	"radatomcastle 4,4"	: async function() {
			//check.　扉をあける呪文が必要
			if( this.player.items.indexOf( "扉をあける呪文" ) == -1 ) {
				await message( "扉をあける呪文がないので、未知のエリアに入れない！" );
				return;
			}
		if( this.player.items.indexOf( "魔法のランプ" ) == -1 ) {
			await message( "魔法のランプを手に入れた！" );
			this.player.items.push( "魔法のランプ" );
		}
	},


	"arefgald 5,1"	: async function() {
	
		if( this.player.items.indexOf( "魔法の金貨" ) == -1 ) {
				await message( "魔法の金貨を持ってきたら勇者と認めよう！" );
			
		} else {
			if( this.player.items.indexOf( "丈夫なじゅうたん" ) == -1 ) {
				await message( "魔法の金貨を持ってきたのか！" );
				await message( "ではお前を勇者と認め、丈夫なじゅうたんを授けよう！", true );
				await message( "丈夫なじゅうたんを手に入れた！" );
				this.player.items.push( "丈夫なじゅうたん" );
			}
		}
	},

	"arefgald 1,1"	: async function() {
			//check.　扉をあける呪文が必要
			if( this.player.items.indexOf( "扉をあける呪文" ) == -1 ) {
				await message( "扉をあける呪文がないので、未知のエリアに入れない！" );
				return;
			}
		if( this.player.items.indexOf( "魔法の金貨" ) == -1 ) {
			await message( "魔法の金貨を手に入れた！" );
			this.player.items.push( "魔法の金貨" );
		}
	},

	"arefgald 4,9"	: async function() {
		if( this.player.items.indexOf( "高価なお酒" ) == -1 ) {
			await message( "高価なお酒を手に入れた！" );
			this.player.items.push( "高価なお酒" );
		}
	},

	"arefgald 7,6"	: async function() {
		if( this.player.items.indexOf( "扉をあける呪文" ) == -1 ) {
			await message( "扉をあける呪文を手に入れた！" );
			this.player.items.push( "扉をあける呪文" );
		}
	},

	"arefgald 9,9"	: async function() {
		
		if( this.player.items.indexOf( "魔法のランプ" ) == -1 ) {
			await message( "立派な祭壇がある！" );
		} else {
			await message( "立派な祭壇の前で魔法のランプをこすると魔神が現れた！" );
				//check.	酒を持っているか
				if( this.player.items.indexOf( "高価なお酒" ) == -1 ) {
					await message( "高価なお酒を持ってきたら願いをかなえてあげよう！" );
					return;
				}
								
			await message( "高価なお酒を飲みながら魔神は言いました。", true );
			await message( "なんでも願いをかなえてあげよう！" );
			if( this.player.items.indexOf( "丈夫なじゅうたん" ) == -1 ) {
				await message( "願いはないのか？", true );
				await message( "いつでも呼んでくれれば願いをかなえてあげるよ。" );
			} else {
				await message( "「丈夫なじゅうたんを、空飛ぶじゅうたんに変えてほしい」だって？" );
				await message( "よしきた、かなえてあげよう！", true );
				await message( "アーブラ・カタブラー！", true );
				await message( "丈夫なじゅうたんは、空飛ぶじゅうたんになった！" );
				await message( "魔神は言いました。", true );
				await message( "それではまた会おう！" );
				var idx = this.player.items.indexOf( "丈夫なじゅうたん" );
				this.player.items.splice( idx, 1 );
				this.player.items.push( "空飛ぶじゅうたん" );
			}
		}
	},

	"arefgald 4,6"	: async function() {
	
		if( this.player.items.indexOf( "空飛ぶじゅうたん" ) == -1 ) {
			await message( "海の向こうにシャフリヤール王の宮殿が見える！" );
		} else {
			await message( "空飛ぶじゅうたんに乗って、海を越えた！" );
			await message( "シャフリヤール王の宮殿に来た！" );
			await message( "シャフリヤール王は言いました、", true );
			var res = await yesno( "わしのけらいになったら、全財産の半分をやろう。どうじゃ？" );
				if( res ) {
					await message( "あなたはシャフリヤール王のけらいになった！", true );
					await message( "ゲームオーバー", true );
					messageDiv.style.backgroundColor = "red";
					freez();
				} else {
					await message( "あなたは、シャフリヤール王に面白い話をいっぱい聞かせました！" );
					await message( "機嫌を良くした王は、大臣の願いを聞き入れることにし、人々が喜ぶ国にすると約束しました！" );
					mapScene.close();
					lastScene.open();
				}
		}
	},

}

